/*
 *  Lucidor - e-book reader
 *  Copyright © 2009-2010  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("resource://lucidor/modules/utils.jsm");

function install_ff_theme() {
    debug("install_ff_theme");
    try {
	do_install_ff_theme();
    } catch (e) {
	debug("E:" + e);	
    }
}

function do_install_ff_theme() {
    let fp = Components.classes["@mozilla.org/filepicker;1"].
	createInstance(Components.interfaces.nsIFilePicker);
    //let strbundle = document.getElementById("strings");
    //let text = strbundle.getString("open_file");
    let text = "Install Firefox Theme";
    fp.init(window, text, Components.interfaces.nsIFilePicker.modeOpen);
    //let sharedbundle = document.getElementById("shared_strings");
    //text = sharedbundle.getString("themes");
    //fp.appendFilter(text, "*");
    text = "Themes";
    fp.appendFilter(text, "*.jar ; *.xpi");
    let res = fp.show();
    if (res != fp.returnOK)
	return;

    let zipreader = Components.classes["@mozilla.org/libjar/zip-reader;1"].
	createInstance(Components.interfaces.nsIZipReader);
    zipreader.open(fp.file);

    if (!zipreader.hasEntry("install.rdf")) {
	debug("NO install.rdf");
	return;
    }
    let inpst = zipreader.getInputStream("install.rdf");
    let parser = Components.classes["@mozilla.org/xmlextras/domparser;1"].
	getService(Components.interfaces.nsIDOMParser);
    let doc = parser.parseFromStream(inpst, null,
				     inpst.available(), "text/xml");

    let EM_NS = "http://www.mozilla.org/2004/em-rdf#";
    let RDF_NS = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";

    // FIXME Should check that typ.textContent == "2"
    // but almost all themes on amo have incorrect em:type
    // Also note that sometimes em:type is a property on Description
    let typ = doc.getElementsByTagNameNS(EM_NS, "type").item(0);
    //if (typ.textContent != "2") {
    if (typ && typ.textContent != "2" && typ.textContent != "4") {
	debug("Not a theme: " + typ.textContent);
	return;
    }

    let app = doc.getElementsByTagNameNS(EM_NS, "targetApplication").item(0);
    if (!app) {
	debug("NO elem");
	return;
    }
    let node = doc.createElementNS(EM_NS, "targetApplication");
    app.parentNode.appendChild(node);
    let node2 = doc.createElementNS(RDF_NS, "Description");
    node.appendChild(node2);

    let node3 = doc.createElementNS(EM_NS, "id");
    text = doc.createTextNode("Lucidor@lucidor.org");
    node3.appendChild(text);
    node2.appendChild(node3);

    node3 = doc.createElementNS(EM_NS, "minVersion");
    text = doc.createTextNode("0.7");
    node3.appendChild(text);
    node2.appendChild(node3);

    node3 = doc.createElementNS(EM_NS, "maxVersion");
    text = doc.createTextNode("1.*");
    node3.appendChild(text);
    node2.appendChild(node3);

    let main_control = Components.classes["@lucidor.org/mainControlService;1"].
	getService().wrappedJSObject;
    let outfil = main_control.get_tempdir();
    outfil.append("lucidor.xpi");
    outfil.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
    outfil.remove(false);
    fp.file.copyTo(outfil.parent, outfil.leafName);

    let domser = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"].
        createInstance(Components.interfaces.nsIDOMSerializer);
    let install_rdf = domser.serializeToString(doc);
    dump(install_rdf + "\n");
    let sis = Components.classes["@mozilla.org/io/string-input-stream;1"].
        createInstance(Components.interfaces.nsIStringInputStream);
    sis.setData(install_rdf, install_rdf.length);

    let zipwriter = Components.classes["@mozilla.org/zipwriter;1"].
	createInstance(Components.interfaces.nsIZipWriter);
    zipwriter.open(outfil, 0x04);

    zipwriter.removeEntry("install.rdf", false);
    zipwriter.addEntryStream("install.rdf", null, 6, sis, false);
    zipwriter.close();

    let browser = document.getElementById("hidden_browser");
    let fph = Components.classes["@mozilla.org/network/protocol;1?name=file"].getService(Components.interfaces.nsIFileProtocolHandler);
    let uri = fph.getURLSpecFromFile(outfil);
    browser.loadURI(uri, null, null);
}
