/*
 *  Lucidor - e-book reader
 *  Copyright © 2008-2010  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("resource://lucidor/modules/utils.jsm");

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var prefs;
var old_bookcase_file;
var new_bookcase_file;

function init() {
    prefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefService).
	getBranch("lucidor.");

    let tp = document.getElementById("path_text");
    try {
	let file = prefs.getComplexValue("bookcase.folder",
					 Components.interfaces.nsILocalFile);
	tp.value = file.path;
	old_bookcase_file = file;
    } catch (e) {
	// FIXME
    }

    /* Font list */
    let pref = document.getElementById("font.name.serif.x-western");
    let current = pref.value;
    let flist = document.getElementById("font_list");
    let fpop = document.getElementById("font_popup");
    let fe = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
	.createInstance(Components.interfaces.nsIFontEnumerator);
    let fonts = fe.EnumerateFonts("x-western", "", {});
    for (let f in loop(fonts)) {
	let item = document.createElementNS(XUL_NS, "menuitem");
	item.setAttribute("value", f);
	item.setAttribute("label", f);
	fpop.appendChild(item);
	if (f == current)
	    flist.value = f;
    }
    if (!flist.value && current) {
	let item = document.createElementNS(XUL_NS, "menuitem");
	item.setAttribute("value", current);
	item.setAttribute("label", current);
	fpop.appendChild(item);
	flist.value = current;
    }
}

function syncfrom_use_doc_fonts() {
    let pref = document.getElementById("browser.display.use_document_fonts");
    return pref.value != 0;
}

function syncto_use_doc_fonts() {
    if (document.getElementById("useDocumentFonts").checked)
	return 1;
    return 0;
}

function accept() {
    /*
    if (old_bookcase_file && new_bookcase_file &&
	!new_bookcase_file.equals(old_bookcase_file)) {
	let files = [];
	for (let book in bookcase) {
	    file = book...;
	    if (old_bookcase_file.contains(file, false))
		files.push(file);
	}
	if (files) {
	    let prompts = ...;
	    let text = "Your bookcase contains books that are stored in the old bookcase directory. Do you want to move them to the new bookcase directory?";
	    let migrate = prompts.confirm();
	    if (migrate) {
		for (let file in loop(files)) {
		    let name = "FIXME";
		    try {
			file.moveTo(new_bookcase_file, name);
		    } catch (e) {

		    }
		    // update bookcase book location
		}
	    }
	}
    }
    */
}

function select_directory() {
    let fp = Components.classes["@mozilla.org/filepicker;1"].
	createInstance(Components.interfaces.nsIFilePicker);
    let strbundle = document.getElementById("strings");
    let title = strbundle.getString("select_path.title");
    fp.init(window, title, Components.interfaces.nsIFilePicker.modeGetFolder);

    let dir;
    try {
	dir = prefs.getComplexValue("bookcase.folder",
				    Components.interfaces.nsILocalFile);
    } catch (e) {
    }
    if (dir)
	fp.displayDirectory = dir;

    let res = fp.show();
    if (res == fp.returnOK) {
	prefs.setComplexValue("bookcase.folder",
			      Components.interfaces.nsILocalFile, fp.file);
	let tp = document.getElementById("path_text");
	tp.value = fp.file.path;
	new_bookcase_file = fp.file;
    }
}
