/*
 *  Lucidor - e-book reader
 *  Copyright © 2009  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var main;
var background;
var finish2;
var bcase;

function debug(msg) {
    try {
	dump("DEBUG: " + msg + "\n");
	/*
	let cons = Components.classes["@mozilla.org/consoleservice;1"].
	    getService(Components.interfaces.nsIConsoleService);
	cons.logStringMessage(msg);
	 */
    } catch (e) {
    }
}

function init() {
    bcase = window.arguments[0];
    finish2 = window.arguments[1];
    debug("FFF:" + bcase + ":" + finish2);
    background = Components.classes["@mozilla.org/thread-manager;1"].
	getService().newThread(1);
    main = Components.classes["@mozilla.org/thread-manager;1"].
	getService().mainThread;

    let label = document.getElementById("note");
    let text = document.createTextNode(bcase.update_message);
    label.appendChild(text);

    bcase.run_main = run_main;
    bcase.run_background = run_background;
    bcase.sync_cache(this);
}

function run_main(func, sync) {
    debug("run_main");
    let x_thread = new xThread(func);
    if (sync)
	main.dispatch(x_thread, main.DISPATCH_SYNC);
    else
	main.dispatch(x_thread, main.DISPATCH_NORMAL);
}

function run_background(func, sync) {
    debug("run_background");
    let x_thread = new xThread(func);
    if (sync)
	background.dispatch(x_thread, background.DISPATCH_SYNC);
    else
	background.dispatch(x_thread, background.DISPATCH_NORMAL);
}

function update(i) {
    let meter = document.getElementById("pm");
    meter.value = i * 100;
}

function hello(i) {
    debug("Processing catalog: " + i);
    function update_meter() {
	update(i);
    }
    let x_thread = new xThread(update_meter);
    main.dispatch(x_thread, main.DISPATCH_NORMAL);
}

function finish_old() {
    let x_thread = new xThread(do_finish);
    main.dispatch(x_thread, main.DISPATCH_NORMAL);
}

function finish() {
    debug("do_finish");
    try {
	background.shutdown();
    } catch (e) {
    }

    if (finish2)
	finish2();
    window.close();
}

function doCancel() {
    bcase.cancel_sync();
    return true;
}

var xThread = function(func) {
    this.func = func;
};

xThread.prototype = {
    run: function() {
	//debug("xThread.run: " + this.func + ";");
	try {
	    this.func();
	    this.func = null;
	} catch (e) {
	    Components.utils.reportError(e);
	}
    },

    QueryInterface: function(iid) {
	if (iid.equals(Components.interfaces.nsIRunnable) ||
	    iid.equals(Components.interfaces.nsISupports)) {
            return this;
	}
	throw Components.results.NS_ERROR_NO_INTERFACE;
    }
};
