/*
 *  Lucidor - e-book reader
 *  Copyright © 2009  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

function init() {
    add_metaitem("title", true);
    add_metaitem("language", true);
}

predef = { language: [ "en", "fr", "de", "ru", "es" ] };

var idnum = 0;

function get_id() {
    return idnum++;
}

function add_metaitem(type, sticky) {
    let id = get_id();
    let hbox = document.createElement("hbox");
    hbox.setAttribute("id", "meta" + id);
    let item = document.createElement("label");
    item.setAttribute("control", "control" + id);
    let text = document.createTextNode(type);
    item.appendChild(text);
    hbox.appendChild(item);
    if (type == "date") {
	let timezones = ["None", "±0 (UTC, GMT, London)",
			 "+1 (CET, Karl-Marx-Stadt)", "+2 (EET, Minsk)",
			 "+3 (Leningrad)", "+3:30 (Tehran)",
			 "+4 (Tbilisi)", "+4:30 (Kabul)",
			 "+5 (Islamabad)", "+5:30 (Dehli)", "+5:45 (Katmandu)",
			 "+6 (Dhaka)", "+6:30 (Rangoon)",
			 "+7 (Ho-Chi-Minh City)", "+8 (Beijing)",
			 "+9 (Pyongyang)", "+10 (Vladivostok)",
			 "+11 (Magadan)", "+12 (Wellington)",
			 //"+13", "+14"
			 //"-12", "-11",
			 "-10 (Honolulu)", "-9 (AKST, Anchorage)",
			 "-8 (PST, Seattle)", "-7 (MST, Edmonton)",
			 "-6 (CST, Mexico City)", "-5 (EST, Havana)",
			 "-4:30 (VST, Caracas)",
			 "-4 (Buenos Aires)", "-3 (Santiago)",
			 //"-2", "-1",
			 "Other"];
	// ____-__-__ __:__ |±__:__| (tz dropdown 
	// event
    }
    if (type == "language") {
	// FIXME snabblista med vanligaste valen: "English", "English (American)", "English (British)", "French" ... "Other"
	//item = document.createElement("menulist");
	//item = document.createElement("menupopup");
	//item = document.createElement("menuitem");
    }
    item = document.createElement("textbox");
    item.setAttribute("id", "control" + id);
    hbox.appendChild(item);
    if (!sticky) {
	item = document.createElement("button");
	item.setAttribute("label", "Remove");
	item.setAttribute("oncommand", "remove_meta('meta" + id + "')");
	hbox.appendChild(item);
    }
    let box = document.getElementById("metabox");
    box.appendChild(hbox);
}

function add_meta() {
    let item = document.getElementById("metalist");
    add_metaitem(item.value, false);
}

function remove_meta(id) {
    let item = document.getElementById(id);
    item.parentNode.removeChild(item);
}
