/*
 *  Lucidor - e-book reader
 *  Copyright © 2008-2010  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function debug(msg) {
    if (false) {
	try {
	    let cons = Components.classes["@mozilla.org/consoleservice;1"].
		getService(Components.interfaces.nsIConsoleService);
	    cons.logStringMessage(msg);
	} catch (e) {
	}
    }
}

function loop(thing) {
    if (!thing)
	return;
    for (let i = 0; i < thing.length; i++)
	yield thing[i];
}

function cmdlineHandler() {
    this.wrappedJSObject = this;
    this.defaultURIS = [];
}

cmdlineHandler.prototype = {
    classDescription: "cmdlineHandler",
    classID: Components.ID("{e58cf033-3220-4e4d-afe4-aae5eeb02074}"),
    contractID: "@lucidor.org/cmdlineHandler;1",
    _xpcom_factory: cmdlineHandlerFactory,
    _xpcom_categories: [{ category: "command-line-handler",
			  entry: "m-lucidor-cmdline" }],
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports,
					   Components.interfaces.nsICommandLineHandler]),

    helpInfo: "",

    handle: function(commandLine) {
	let uris = [];
	for (let i = 0; i < commandLine.length; i++) {
	    let uri_spec = commandLine.getArgument(i);
	    uris.push(commandLine.resolveURI(uri_spec));
	}
	if (commandLine.state == commandLine.STATE_INITIAL_LAUNCH)
	    this.defaultURIS = uris;
	else {
	    let main_control = Components.classes["@lucidor.org/mainControlService;1"].getService().wrappedJSObject;
	    for (let duri in loop(uris))
		main_control.add_epub_tab(duri.spec);
	    commandLine.preventDefault = true;
	}
	commandLine.removeArguments(0, commandLine.length - 1);
    }
};

var serviceObject = new cmdlineHandler();

var cmdlineHandlerFactory = {
    createInstance: function(outer, aIID) {
	if (outer != null)
	    throw Components.results.NS_ERROR_NO_AGGREGATION;
	return serviceObject.QueryInterface(aIID);
    }
};

var components = [cmdlineHandler];

if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
