/*
 *  Lucidor - e-book reader
 *  Copyright © 2008-2010  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function debug(msg) {
    if (false) {
	try {
	    let cons = Components.classes["@mozilla.org/consoleservice;1"].
		getService(Components.interfaces.nsIConsoleService);
	    cons.logStringMessage(msg);
	} catch (e) {
	}
    }
}

function loop(thing) {
    if (!thing)
	return;
    for (let i = 0; i < thing.length; i++)
	yield thing[i];
}

function epubURIContentListener() {
    this.loadCookie = null;
    this.parentContentListener = null;
    this.wrappedJSObject = this;
}

epubURIContentListener.prototype = {
    classDescription: "epubURIContentListener",
    classID: Components.ID("{59c9809d-045e-41b7-ba93-0f79b00a23cd}"),
    contractID: "@lucidor.org/epubURIContentListener;1",
    //_xpcom_categories: [{ category: "app-startup" }],
    //_xpcom_categories: [{ category: "profile-after-change" }],
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports,
					   Components.interfaces.nsIURIContentListener,
					   Components.interfaces.nsIClassInfo,
					   Components.interfaces.nsISupportsWeakReference,
					   Components.interfaces.nsIObserver]),
 
    canHandleContent: function(aContentType, aIsContentPreferred) {
	if (aContentType == "application/epub+zip")
	    return true;
	return false;
    },

    doContent: function(aContentType, aIsContentPreferred, aRequest, aContentHandler) {
	if (aContentType == "application/epub+zip") {
	    let main_control = Components.classes["@lucidor.org/mainControlService;1"].
		getService().wrappedJSObject;
	    main_control.add_epub_tab(aRequest.name);
	    return true;
	}

	throw Components.results.NS_ERROR_NOT_IMPLEMENTED;	// FIXME
    },

    isPreferred: function(aContentType) {
	if (aContentType == "application/epub+zip")
	    return true;
	return false;
    },

    onStartURIOpen: function(aURI) {
	return false;
    },

    getHelperForLanguage: function() {
    },

    getInterfaces: function() {
    },

    observe: function(subject, topic, data) {
	/*
	if (topic == "profile-after-change" || topic == "app-startup") {
	    let uriLoader = Components.classes["@mozilla.org/uriloader;1"].
		getService(Components.interfaces.nsIURILoader);
	    uriLoader.registerContentListener(contentListener);
	}
	*/
    }
};

//var contentListener = new epubURIContentListener();

var components = [epubURIContentListener];

if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
