/*
 *  Lucidor - e-book reader
 *  Copyright © 2008-2010  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function debug(msg) {
    if (false) {
	try {
	    let cons = Components.classes["@mozilla.org/consoleservice;1"].
		getService(Components.interfaces.nsIConsoleService);
	    cons.logStringMessage(msg);
	} catch (e) {
	}
    }
}

function loop(thing) {
    if (!thing)
	return;
    for (let i = 0; i < thing.length; i++)
	yield thing[i];
}

const SCHEME = "x-lucidor";

function lucidorProtocol() {
}

lucidorProtocol.prototype = {
    classDescription: "lucidorProtocol",
    classID: Components.ID("{bb1fc3dc-7623-45b8-ba6e-b3b68ed5c50e}"),
    contractID: "@mozilla.org/network/protocol;1?name=" + SCHEME,
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports,
					   Components.interfaces.nsIProtocolHandler]),

    defaultPort: -1,
    protocolFlags: Components.interfaces.nsIProtocolHandler.URI_NOAUTH |
	Components.interfaces.nsIProtocolHandler.URI_IS_LOCAL_FILE,
    scheme: SCHEME,

    allowPort: function(port, scheme) {
        return false;
    },

    newChannel: function(URI) {
	debug("My newChannel: " + URI.spec);

	let bookman = Components.classes["@lucidor.org/bookmanagerService;1"].
		getService().wrappedJSObject;
	try {
	    return bookman.getChannel(URI);
	} catch (e) {
	    debug("Error: Invalid: " + e);

	    // FIXME What should be returned/thrown in this case?
	    //throw Components.results.NS_ERROR_FAILURE;

	    let ios = Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService);
	    return ios.newChannel("file:///FIXMEqwerty", null, null);
	}
    },

    newURI: function(spec, originCharset, baseURI) {
        let uri = Components.classes["@mozilla.org/network/standard-url;1"].
		createInstance(Components.interfaces.nsIStandardURL);
	uri.init(uri.URLTYPE_STANDARD, this.defaultPort, spec,
		 originCharset, baseURI);

        return uri.QueryInterface(Components.interfaces.nsIURI);
    }
};

var components = [lucidorProtocol];

if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
